## pwl-pc-services 4.3.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(pwlLinuxPkgs C)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3")

set(DEB_EXTRA "${PROJECT_SOURCE_DIR}/deb_extra")

add_subdirectory(gdbus)
add_subdirectory(pwl-core)
add_subdirectory(pwl-madpt)
add_subdirectory(pwl-fwupdate)
add_subdirectory(pwl-pref)

install(CODE "execute_process(COMMAND bash ${DEB_EXTRA}/install)")

set(DEFAULT_INSTALL_PREFIX "")

if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX ${DEFAULT_INSTALL_PREFIX} CACHE PATH "default install prefix" FORCE)
endif()
message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")

install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/opt/pwl" FILE_PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ DESTINATION "${CMAKE_INSTALL_PREFIX}/opt")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/lib/systemd/system/" DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/systemd/system")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/usr/share/dbus-1/system.d/" DESTINATION "${CMAKE_INSTALL_PREFIX}/usr/share/dbus-1/system.d")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/usr/lib/udev/rules.d/" DESTINATION "${CMAKE_INSTALL_PREFIX}/usr/lib/udev/rules.d")
install(DIRECTORY "${PROJECT_BINARY_DIR}/release/dpkg/etc/systemd/system/ModemManager.service.d/" DESTINATION "${CMAKE_INSTALL_PREFIX}/etc/systemd/system/ModemManager.service.d")
install(FILES "${PROJECT_SOURCE_DIR}/common/mcc_mnc_list.csv" DESTINATION "${CMAKE_INSTALL_PREFIX}/opt/pwl/")

set(CPACK_GENERATOR "DEB")
set(CPACK_PACKAGE_NAME "pwl-linux-pkgs")
set(CPACK_PACKAGE_VERSION "4.3.5")
set(CPACK_DEBIAN_PACKAGE_SECTION "base")
set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")
set(CPACK_DEBIAN_PACKAGE_MAINTAINER "PWL")
set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "PWL Linux service packages")
set(CPACK_DEBIAN_PACKAGE_PRIORITY "standard")
set(CPACK_DEBIAN_PACKAGE_CONTROL_EXTRA "${DEB_EXTRA}/postinst;${DEB_EXTRA}/postrm;${DEB_EXTRA}/preinst;${DEB_EXTRA}/prerm")
include(CPack)

# Generate uninstall target
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== debian/changelog ===
pwl-pc-services (4.3.5-0ubuntu1~ppa1) plucky; urgency=medium

  * Initial release (LP: #2084776).

 -- Yao Wei (魏銘廷) <yao.wei@canonical.com>  Mon, 10 Mar 2025 14:50:04 +0800

=== debian/control ===
Source: pwl-pc-services
Section: non-free/net
Priority: optional
Maintainer: Canonical Commercial Engineering Group <commercial-engineering@canonical.com>
Uploaders: Yao Wei (魏銘廷) <yao.wei@canonical.com>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 dh-apparmor,
 dh-modaliases,
 libdbus-1-dev,
 libglib2.0-dev,
 libmbim-glib-dev (>= 1.31.2-0ubuntu4),
 libmm-glib-dev,
 libudev-dev,
 libxml2-dev,
 openssl,
 pkgconf,
 udev,
Standards-Version: 4.7.0
Homepage: https://github.com/palcomwireless/linux_pkgs
Vcs-Browser: https://git.launchpad.net/~oem-solutions-engineers/pwl-pc-services
Vcs-Git: https://git.launchpad.net/~oem-solutions-engineers/pwl-pc-services
Rules-Requires-Root: no
XS-Autobuild: yes

Package: pwl-pc-services
Architecture: any
Depends:
 ${misc:Depends},
 pwl-core-service,
 pwl-fwupdate-service,
 pwl-madpt-service,
 pwl-pref-service,
 pwl-unlock-service,
XB-Modaliases: ${modaliases}
Description: Service packages for Palcom Wireless WWAN modules
 This metapackage installs all services for Palcom Wireless WWAN modules

Package: pwl-core-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, modemmanager
Description: Core controller of Palcom Wireless services
 The package provides core controller of Palcom Wireless services

Package: pwl-fwupdate-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pwl-core-service
Recommends: pwl-firmware
Description: Firmware update service for Palcom Wireless WWAN modules
 The package provides Firmware update service for Palcom Wireless WWAN modules

Package: pwl-madpt-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pwl-core-service
Description: Module communication adapter service for Palcom Wireless WWAN modules
 The package provides Module communication adapter service for Palcom Wireless
 WWAN modules

Package: pwl-pref-service
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, pwl-core-service
Description: Config preference for the Palcom Wireless packages
 The package config preference for the Palcom Wireless packages

Package: pwl-unlock-service
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, pwl-core-service, libmbim-utils
Description: FCC unlock procedure for the Palcom Wireless WWAN modules
 The package performs the FCC unlock procedure for the module.

Package: pwl-test-quick-suspend-resume
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
XB-Modaliases: ${modaliases}
Description: ModemManager drop-in file for system suspend
 The drop-in file will change ModemManager execution parameter to allow modem
 object not being removed during host suspension.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with modaliases

current_dir=$(shell pwd)
override_dh_auto_configure:
	dh_auto_configure --sourcedirectory=. --builddirectory=build -- \
		--install-prefix="$(current_dir)/debian/tmp"

override_dh_installsystemd:
	dh_installsystemd -ppwl-core-service --name=pwl_core pwl-core.service
	dh_installsystemd -ppwl-fwupdate-service --name=pwl_fwupdate pwl-fwupdate.service
	dh_installsystemd -ppwl-madpt-service --name=pwl_madpt pwl-madpt.service
	dh_installsystemd -ppwl-pref-service --name=pwl_pref pwl-pref.service

override_dh_auto_build:
	cmake --build build

override_dh_auto_install:
	cmake --install build

override_dh_auto_clean:
	dh_auto_clean -- \
		rm -rf debian/tmp
	rm -rf build/

=== debian/watch ===
version=4
#opts="mode=git,pgpmode=gittag" \ # TODO: https://bugs.debian.org/1015233
opts="mode=git" \
https://github.com/palcomwireless/linux_pkgs.git refs/tags/@ANY_VERSION@

## pwl-pc-services 4.4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,7 +30,7 @@
 
 set(CPACK_GENERATOR "DEB")
 set(CPACK_PACKAGE_NAME "pwl-linux-pkgs")
-set(CPACK_PACKAGE_VERSION "4.3.5")
+set(CPACK_PACKAGE_VERSION "4.4.3")
 set(CPACK_DEBIAN_PACKAGE_SECTION "base")
 set(CPACK_DEBIAN_FILE_NAME DEB-DEFAULT)
 set(CPACK_DEBIAN_PACKAGE_ARCHITECTURE "amd64")

=== gdbus/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.10)

SET(XML_FILE_LIST com.pwl.core.xml)
SET(XML_GEN_FILE_LIST CoreGdbusGenerated)

LIST(LENGTH XML_FILE_LIST XML_FILE_LIST_LEN)
LIST(LENGTH XML_GEN_FILE_LIST NAME_LIST_LEN)
MATH(EXPR XML_FILE_LIST_LEN "${XML_FILE_LIST_LEN}-1")
MATH(EXPR NAME_LIST_LEN "${NAME_LIST_LEN}-1")

IF(${XML_FILE_LIST_LEN} EQUAL ${NAME_LIST_LEN})
    FOREACH(INDEX RANGE 0 ${XML_FILE_LIST_LEN})
        LIST(GET XML_FILE_LIST ${INDEX} XML)
        LIST(GET XML_GEN_FILE_LIST ${INDEX} NAME_TMP)
        EXECUTE_PROCESS(COMMAND gdbus-codegen --interface-prefix com.pwl. --c-namespace pwl --generate-c-code ${PROJECT_BINARY_DIR}/${NAME_TMP} ${PROJECT_SOURCE_DIR}/gdbus/${XML})
    ENDFOREACH(INDEX)
ELSE (${XML_FILE_LIST_LEN} EQUAL ${NAME_LIST_LEN})
    MESSAGE(FATAL_ERROR "The length (${XML_FILE_LIST_LEN}) of xml files list does not equal to the length(${NAME_LIST_LEN}) of the generated files name list")
ENDIF(${XML_FILE_LIST_LEN} EQUAL ${NAME_LIST_LEN})

=== pwl-core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/includes)
INCLUDE_DIRECTORIES(/usr/include/gio-unix-2.0)

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/ /usr/local/include/libmbim-glib /usr/include/libmbim-glib)

link_directories(${PROJECT_BINARY_DIR}/)

add_executable(pwl_core pwl_core.c ${PROJECT_SOURCE_DIR}/common/common.c ${PROJECT_BINARY_DIR}/CoreGdbusGenerated.c)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0 gio-2.0)

target_link_libraries(pwl_core ${GLIB_LIBRARIES} libmbim-glib.so)

target_include_directories(pwl_core PRIVATE ${GLIB_INCLUDE_DIRS})

project(pwlLinuxPkg VERSION 1.0 LANGUAGES C)

=== pwl-fwupdate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

INCLUDE_DIRECTORIES(inc)
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/includes)
INCLUDE_DIRECTORIES(/usr/include/gio-unix-2.0)
INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/)
INCLUDE_DIRECTORIES(/usr/include/libxml2/)

file(GLOB FB_SRC fastboot/*.cpp)

add_compile_options(-Wno-ignored-attributes)

add_executable(pwl_fwupdate pwl_fwupdate.c fb_programing.c ${FB_SRC} ${PROJECT_SOURCE_DIR}/common/common.c ${PROJECT_BINARY_DIR}/CoreGdbusGenerated.c)

target_link_libraries(pwl_fwupdate ${GLIB_LIBRARIES} pthread xml2)

target_include_directories(pwl_fwupdate PRIVATE ${GLIB_INCLUDE_DIRS})

project(pwlLinuxPkg VERSION 1.0)

=== pwl-madpt/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/includes)
INCLUDE_DIRECTORIES(/usr/include/gio-unix-2.0)

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/ /usr/local/include/libmbim-glib /usr/include/libmbim-glib)

link_directories(${PROJECT_BINARY_DIR}/)

add_executable(pwl_madpt
               pwl_madpt.c
               pwl_mbimdeviceadpt.c
               pwl_atchannel.c
               ${PROJECT_SOURCE_DIR}/common/common.c
               ${PROJECT_BINARY_DIR}/CoreGdbusGenerated.c)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0 gio-2.0)

target_link_libraries(pwl_madpt ${GLIB_LIBRARIES} libmbim-glib.so)

target_include_directories(pwl_madpt PRIVATE ${GLIB_INCLUDE_DIRS})

project(pwlLinuxPkg VERSION 1.0 LANGUAGES C)

=== pwl-pref/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/includes)
INCLUDE_DIRECTORIES(/usr/include/gio-unix-2.0)

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/)

link_directories(${PROJECT_BINARY_DIR}/)

add_executable(pwl_pref pwl_pref.c ${PROJECT_SOURCE_DIR}/common/common.c ${PROJECT_BINARY_DIR}/CoreGdbusGenerated.c)

find_package(PkgConfig REQUIRED)
pkg_check_modules(GLIB REQUIRED glib-2.0 gio-2.0)

target_link_libraries(pwl_pref ${GLIB_LIBRARIES} pthread)

target_include_directories(pwl_pref PRIVATE ${GLIB_INCLUDE_DIRS})

project(pwlLinuxPkg VERSION 1.0 LANGUAGES C)

=== debian/changelog ===
pwl-pc-services (4.4.3-0ubuntu1~ppa1) questing; urgency=medium

  * New upstream version 4.4.3

 -- Yao Wei (魏銘廷) <yao.wei@canonical.com>  Tue, 08 Jul 2025 15:08:01 +0800

pwl-pc-services (4.3.5-0ubuntu1~ppa3) plucky; urgency=medium

  * d/control: add pwl-test-quick-suspend-resume into pwl-pc-services
    Recommends

 -- Yao Wei (魏銘廷) <yao.wei@canonical.com>  Mon, 30 Jun 2025 16:43:53 +0800

pwl-pc-services (4.3.5-0ubuntu1~ppa2) plucky; urgency=medium

  * debian/control: remove modaliases for pwl-test-quick-suspend-resume

 -- Yao Wei (魏銘廷) <yao.wei@canonical.com>  Thu, 26 Jun 2025 16:09:37 +0800

=== debian/control ===
--- 
+++ 
@@ -33,6 +33,8 @@
  pwl-madpt-service,
  pwl-pref-service,
  pwl-unlock-service,
+Recommends:
+ pwl-test-quick-suspend-resume,
 XB-Modaliases: ${modaliases}
 Description: Service packages for Palcom Wireless WWAN modules
  This metapackage installs all services for Palcom Wireless WWAN modules
@@ -72,7 +74,6 @@
 Package: pwl-test-quick-suspend-resume
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-XB-Modaliases: ${modaliases}
 Description: ModemManager drop-in file for system suspend
  The drop-in file will change ModemManager execution parameter to allow modem
  object not being removed during host suspension.
